Ruby - Bug #11274

Equality inconsistency between Method and UnboundMethod
06/17/2015 08:01 AM - ko1 (Koichi Sasada)

Status: Closed
Priority: Normal
Assignee: matz (Yukihiro Matsumoto)

Target version:

ruby -v: 2.3dev Backport: 2.0.0: UNKNOWN, 2.1: UNKNOWN, 2.2:
UNKNOWN

Description
Method I UnboundMethod [l equality D000000000

module M1
def foo; end
end

module M2
include M1
alias bar foo
end

class C
include M1
include M2

end

c = C.new

c_ml = c.method(:foo0)

c_m2 = c.method(:bar)

p [c_ml, c_m2, c_ml == c_m2, c_m2 == c_ml]
a0

[#<Method: C (M1l) #foo>, #<Method: C(M1l) #bar (foo)>, true, true]
00000000000oo0ooon

0000unboundMethod#== 0000000

module M1
def foo; end
end
module M2
include M1

alias bar foo
end

ubml = Ml.instance_method(:foo0)
ubm?2 M2.instance_method (:bar)

p [ubml, ubm2, ubml==ubm2, ubm2==ubml]
a0

[#<UnboundMethod: M1#foo>, #<UnboundMethod: M2 (M1)#bar (foo)>, false, false]
00ooooooooooo

00000000000o0bo0bo0DonDoDooDooDo0Da0ba0Da0DanD
00000Method#== 000000

* Two method objects are equal if they are bound to the same
* object and refer to the same method definition and their owners are the
* same class or module.

00000o00ooboobonoonoo

module M1
def foo; end
end

module M2
include M1
alias bar foo
end

class C
include M1
include M2

end

c = C.new

c.method (:foo)

c_ml =
c_m2 = c.method(:bar)

p c_ml.owner, c_m2.owner

a0

M1
M2

00000000000000000method#== 000000000000000D00D00DO0DO0D

0000000000000000000000000000000000000000000000000000g
000000D000D000Do00Do00D000D0a0D00000000000D000owner OODDOODOOODOOODOCOD

alias 10000000000000000DO0DOODO

History

#1 - 06/17/2015 03:12 PM - matz (Yukihiro Matsumoto)

000000000000bonoon
000000000Dalias0O00O00O0CCO000ownerd000000O00D00Aas00000000000000DO00DOO0DD

Matz.

#2 - 10/21/2019 05:42 PM - jeremyevans0 (Jeremy Evans)
- Status changed from Open to Closed

This appears to be fixed starting in Ruby 2.3 (the first example returns false instead of true for equality as the owners of the methods are different),
probably by 5e8a147480f87f19a8b96ad3fb33a25tb4bb19b9.
https://bugs.ruby-lang.org/projects/ruby-master/repository/git/revisions/5e8a147480f87f19a8b96ad3fb33a25fb4bb19b9
http://www.tcpdf.org

